-- Ballenfuttermod by acert 2012
-- Find me at modhoster.de


QBallenfuttermod = {};

function QBallenfuttermod.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function QBallenfuttermod:load(xmlFile)
  
	self.hayBale = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ballen.hayBale#index"));
	setVisibility(self.hayBale, false);
	
	
	
	self.objectInRange = QBallenfuttermod.objectInRange;

	
    self.lastQBallenfuttermodArea = 0;
    self.QBallenfuttermodGroundFlag = self:getNextDirtyFlag();

	self.baleSearchNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.baleSearchNode#index"));

end;

function QBallenfuttermod:delete()
end;


function QBallenfuttermod:mouseEvent(posX, posY, isDown, isUp, button)
end;

function QBallenfuttermod:keyEvent(unicode, sym, modifier, isDown)
end;

function QBallenfuttermod:update(dt)

end;

function QBallenfuttermod:updateTick(dt)
  
    if self:getIsActive() then
			
					local bale = self:objectInRange(self.baleSearchNode);
					if bale ~= nil then
						baleId = networkGetObjectId(bale);
						bale = networkGetObject(baleId);
						if getUserAttribute(bale.nodeId, "isHaybale") then
								if self.currentFillType == Fillable.FILLTYPE_UNKNOWN then
									self.fillLevel = 3000;
									self.currentFillType = Fillable.FILLTYPE_GRASS;
									setVisibility(self.hayBale, true);
								end;
						end;
						
						bale:delete();
					end;
				if self.fillLevel < 10 then
							setVisibility(self.hayBale, false);
				end;
						
	end; 
end;
	
	


function QBallenfuttermod:draw()
end;


function QBallenfuttermod:objectInRange(refNode)
    local nearestDistance = 1.1;
    local nearestBale = nil;
    local px, py, pz = getWorldTranslation(refNode);
	for index, item in pairs(g_currentMission.itemsToSave) do
	    itemNode = item.item.nodeId;
	    if getParent(item.item.nodeId) == getRootNode() then
			if getUserAttribute(itemNode, "isHaybale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					index = index;
					nearestBale = item.item;
					nearestObject = itemNode;
					nearestDistance = distance;
				end;
			end;
		end;
	end;	
    return nearestBale;
end;